# background folder
BACKGROUNDS = "backgrounds"

# simple constants for readability with some of my algorithms
RIGHT = (1, 0)
LEFT = (-1, 0)
UP = (-1, 1)
DOWN = (1, 1)

# screen display mode
MODE = (640, 480)

# play field rectangle
# 20 pixel wide blocks * 10 + 11 1 pixel borders = 211
# 20 pixel wide blocks * 20 + 21 1 pixel borders = 421
PLAY_FIELD_RES = ((MODE[0] - 211) / 2, (MODE[1] - 421) / 2, 211, 421)

# Score board
SCORE_BOARD_RES = ((MODE[0] - 200), 50, 180, 150)

# Next box rectangle
NEXT_SCREEN_RES = (90, 100, 107, 107)

# Square piece starting coordinates and rotation matrixes
SQUARE = [
    #pivot
    [0,0],
    # state 1
    [[1, 0], [0,1], [1, 1]]
    ]
S_BLOCK = [
    # pivot
    [1,0],
    # state 1
    [[2,0], [0,1], [1,1]],
    # state 2
    [[1,-1], [2,0], [2,1]]
    ]
Z_BLOCK = [
    # pivot
    [1,0],
    # state 1
    [[0,0], [1,1], [2,1]],
    # state 2
    [[0,0], [0,1], [1,-1]]
    ]
T_BLOCK = [
    #pivot (center of block)
    [1,0],
    # state 1
    [[0,0], [2,0], [1,1]],
    # state 2
    [[1,1], [1,-1], [2,0]],
    # state 3
    [[0,0], [1,-1], [2,0]],
    # state 4
    [[0,0], [1,-1], [1,1]]
    ]
L_RIGHT = [
    #pivot
    [1,0],
    # state 1
    [[0,0], [2,0], [2,1]],
    # state 2
    [[2,-1], [1,-1], [1,1]],
    # state 3
    [[0,0], [2,0], [0,-1]],
    # state 4
    [[1,-1], [1,1], [0,1]],
    ]
L_LEFT = [
    #pivot
    [1,0],
    # state 1
    [[0,0], [2,0], [0,1]],
    # state 2
    [[1,-1], [1,1], [2,1]],
    # state 3
    [[0,0], [2,0], [2,-1]],
    # state 4
    [[0,-1], [1,-1], [1,1]]
    ]
SKINNY = [
    #pivot
    [1,0],
    # state 1
    [[0,0], [2,0], [3,0]],
    # state 2
    [[1,-1], [1,1], [1,2]]
    ]

PIECES = [SQUARE, S_BLOCK, Z_BLOCK,
          L_RIGHT, L_LEFT, SKINNY, T_BLOCK]

SCORES = [40, 100, 300, 1200]
