import os, sys, random, pygame, time, Globals, \
       Constants, Data, copy, GameSounds, Menu
from pygame.locals import *

# Functions
def initialize_event_queue():

    """Sets the events that are allowed on the event queue and turns on
    keyboard repeating"""
    
    pygame.event.set_allowed(None)
    pygame.event.set_allowed(KEYDOWN)
    pygame.event.set_allowed(KEYUP)
    pygame.event.set_allowed(QUIT)
    pygame.key.set_repeat(50, 42)

def initialize_display():
    """Does the pygame initial display code"""
    pygame.display.init()
    Globals.main_display = pygame.display.set_mode(Constants.MODE,
                                                   FULLSCREEN)
    pygame.display.set_caption("That Block Game: by Sam Peterson")
    pygame.mouse.set_visible(False)

def initialize_playfield():

    myimage = pygame.image.load(Globals.background_list[Globals.current_level])
    myimage = myimage.convert()
    Globals.main_display.blit(myimage, (0,0))

    # create the play field graphics and surface object    
    Globals.play_field_screen = \
        Globals.main_display.subsurface(Constants.PLAY_FIELD_RES)
    Globals.play_field_screen.fill(0xFFFFFF)

    block_coor = [Constants.PLAY_FIELD_RES[0] + 1,
                  Constants.PLAY_FIELD_RES[1] + 1, 20, 20]

    # fill up the play field global variable with data
    # FIXME: Play field size should be in Constants.py
    block_color = 0x000000
    for x in range(10):
        Globals.play_field.append([])
        for y in range(20):
            # FIXME: don't think I need this try block any more
            try:
                block_surface = Globals.main_display.subsurface(block_coor)
                block_coor[1] += 21
                block_surface.fill(block_color)
                Globals.play_field[x].append([block_color, block_surface])
            except ValueError:
                print block_coor
        # FIXME: values should be calculated from constants
        block_coor[1] -= 420
        block_coor[0] += 21

    # create the next box graphics and surface object
    block_coor = [Constants.NEXT_SCREEN_RES[0] + 1,
                  Constants.NEXT_SCREEN_RES[1] + 1, 20, 20]
    Globals.next_screen_surface = \
                        Globals.main_display.subsurface(Constants.NEXT_SCREEN_RES)
    Globals.next_screen_surface.fill(0xFFFFFF)

    for x in range(5):
        Globals.next_screen.append([])
        for y in range(5):
            block_surface = Globals.main_display.subsurface(block_coor)
            block_coor[1] += 21
            block_surface.fill(block_color)
            Globals.next_screen[x].append([block_color, block_surface])
        # FIXME: should be calculated probably
        block_coor[1] -= 105
        block_coor[0] += 21

    Globals.redraw_surfaces.append([Globals.play_field_screen,
                                    (Constants.PLAY_FIELD_RES[0],
                                     Constants.PLAY_FIELD_RES[1])])

    Globals.redraw_surfaces.append([Globals.next_screen_surface,
                                   (Constants.NEXT_SCREEN_RES[0],
                                    Constants.NEXT_SCREEN_RES[1])])
    # update the display    
    pygame.display.flip()

def initialize_font():
    pygame.font.init()
    # FIXME: again, should be in Constants.
    Globals.font = pygame.font.Font("Vera.ttf", 20)
    # note, text height is about 24 pixels at 20 pt

    # score label
    mysurf = Globals.font.render("Score", True, (255,255,255), (0,0,0))
    Score_surf = Globals.main_display.subsurface(
        Constants.SCORE_BOARD_RES[0] + 5,
        Constants.SCORE_BOARD_RES[1] + 5,
        mysurf.get_width(),
        mysurf.get_height())
    Score_surf.blit(mysurf, (0,0))
    # actual score rendering surface
    Globals.score_surf = Globals.main_display.subsurface(
        Constants.SCORE_BOARD_RES[0] + 5,
        Constants.SCORE_BOARD_RES[1] + mysurf.get_height(),
        Constants.SCORE_BOARD_RES[3] - 5,
        mysurf.get_height())

    # Lines label
    mysurf = Globals.font.render("Lines", True, (255,255,255), (0,0,0))
    Lines_surf = Globals.main_display.subsurface(
        Constants.SCORE_BOARD_RES[0] + 5,
        Constants.SCORE_BOARD_RES[1] + mysurf.get_height() * 2,
        mysurf.get_width(),
        mysurf.get_height())
    Lines_surf.blit(mysurf, (0,0))
    # actual lines rendering surface
    Globals.lines_surf = Globals.main_display.subsurface(
        Constants.SCORE_BOARD_RES[0] + 5,
        Constants.SCORE_BOARD_RES[1] + mysurf.get_height() * 3,
        mysurf.get_width(),
        mysurf.get_height())

    # Level Label
    mysurf = Globals.font.render("Level", True, (255,255,255), (0,0,0))
    Level_surf = Globals.main_display.subsurface(
        Constants.SCORE_BOARD_RES[0] + 5,
        Constants.SCORE_BOARD_RES[1] + mysurf.get_height() * 4,
        mysurf.get_width(),
        mysurf.get_height())
    Level_surf.blit(mysurf, (0,0))

    # actual level rendering surface
    Globals.level_surf = Globals.main_display.subsurface(
        Constants.SCORE_BOARD_RES[0] + 5,
        Constants.SCORE_BOARD_RES[1] + mysurf.get_height() * 5,
        mysurf.get_width(),
        mysurf.get_height())

    # put up starting values
    touch_score_board(Globals.level_surf, str(Globals.current_level))
    touch_score_board(Globals.lines_surf, str(Globals.total_lines))
    touch_score_board(Globals.score_surf, str(Globals.score))

def touch_score_board(render_surf, text):
    """Given a ScoreBoard surface and some text, renders changes to the
    score board"""
    mysurf = Globals.font.render(text, True, (255,255,255), (0,0,0))
    render_surf.blit(mysurf, (0,0))

def initialize_score_board():
    score_board_surface = Globals.main_display.subsurface(
        Constants.SCORE_BOARD_RES)
    score_board_surface.fill(0xFFFFFF)
    score_board_smaller_surface = Globals.main_display.subsurface(
        Constants.SCORE_BOARD_RES[0] + 1,
        Constants.SCORE_BOARD_RES[1] + 1,
        Constants.SCORE_BOARD_RES[2] - 2,
        Constants.SCORE_BOARD_RES[3] - 2)
    score_board_smaller_surface.fill(0x000000)
    Globals.redraw_surfaces.append([score_board_surface,
                                    Constants.SCORE_BOARD_RES])
    # score label
    mysurf = Globals.font.render("Score", True, (255,255,255), (0,0,0))
    Score_surf = Globals.main_display.subsurface(
        Constants.SCORE_BOARD_RES[0] + 5,
        Constants.SCORE_BOARD_RES[1] + 5,
        mysurf.get_width(),
        mysurf.get_height())
    Score_surf.blit(mysurf, (0,0))
    # actual score rendering surface
    Globals.score_surf = Globals.main_display.subsurface(
        Constants.SCORE_BOARD_RES[0] + 5,
        Constants.SCORE_BOARD_RES[1] + mysurf.get_height(),
        Constants.SCORE_BOARD_RES[3] - 5,
        mysurf.get_height())

    # Lines label
    mysurf = Globals.font.render("Lines", True, (255,255,255), (0,0,0))
    Lines_surf = Globals.main_display.subsurface(
        Constants.SCORE_BOARD_RES[0] + 5,
        Constants.SCORE_BOARD_RES[1] + mysurf.get_height() * 2,
        mysurf.get_width(),
        mysurf.get_height())
    Lines_surf.blit(mysurf, (0,0))
    # actual lines rendering surface
    Globals.lines_surf = Globals.main_display.subsurface(
        Constants.SCORE_BOARD_RES[0] + 5,
        Constants.SCORE_BOARD_RES[1] + mysurf.get_height() * 3,
        mysurf.get_width(),
        mysurf.get_height())

    # Level Label
    mysurf = Globals.font.render("Level", True, (255,255,255), (0,0,0))
    Level_surf = Globals.main_display.subsurface(
        Constants.SCORE_BOARD_RES[0] + 5,
        Constants.SCORE_BOARD_RES[1] + mysurf.get_height() * 4,
        mysurf.get_width(),
        mysurf.get_height())
    Level_surf.blit(mysurf, (0,0))

    # actual level rendering surface
    Globals.level_surf = Globals.main_display.subsurface(
        Constants.SCORE_BOARD_RES[0] + 5,
        Constants.SCORE_BOARD_RES[1] + mysurf.get_height() * 5,
        mysurf.get_width(),
        mysurf.get_height())

    # put up starting values
    touch_score_board(Globals.level_surf, str(Globals.current_level))
    touch_score_board(Globals.lines_surf, str(Globals.total_lines))
    touch_score_board(Globals.score_surf, str(Globals.score))


def initialize_data():
    """Sets up the data structures to be used with the game"""
    Globals.clock = pygame.time.Clock()
    Globals.next_piece = create_piece()
    Globals.next_piece.move(1, Constants.RIGHT)
    Globals.next_piece.move(1, Constants.DOWN)
    Globals.next_piece.draw(Globals.next_screen)
    Globals.current_piece = create_piece()
    Globals.current_piece.move(4, Constants.RIGHT, False)

def handle_events():
    """Handle the incoming events"""
    try:
        for event in pygame.event.get():
            if event.type == QUIT:
                quit_program()
            if event.type == KEYDOWN:
                if event.key == K_LCTRL:
                    # toggle pause
                    Globals.pause = True
                    pygame.mixer.pause()
                    Globals.scratch_surf = Globals.main_display.copy()
                    Globals.main_display.fill(0x000000)
                    # don't handle any other events
                    return
                if event.key == ord('q'):
                    quit_program()
                if event.key == ord('7'):
                    Globals.scratch_surf = Globals.main_display.copy()
                    if Globals.fullscreen:
                        pygame.display.set_mode(Constants.MODE)
                        Globals.fullscreen = False
                    else:
                        pygame.display.set_mode(Constants.MODE,
                                                pygame.FULLSCREEN)
                        Globals.fullscreen = True
                    Globals.main_display.blit(Globals.scratch_surf, (0,0))
                if event.key == K_SPACE and Globals.key_up:
                    Globals.key_up = False # prevent repeat on rotate
                    Globals.current_piece.rotate(Constants.LEFT)
                if event.key == K_UP and Globals.key_up:
                    Globals.key_up = False # prevent repeat on rotate
                    Globals.current_piece.rotate(Constants.RIGHT)
                if event.key == K_RIGHT:
                    Globals.current_piece.move(1, Constants.RIGHT)
                if event.key == K_LEFT:
                    Globals.current_piece.move(1, Constants.LEFT)
                if event.key == K_DOWN:
                    Globals.current_piece.move(1, Constants.DOWN)
                    Globals.drop_on = True
                    Globals.drop_counter += 1
            if event.type == KEYUP:
                if event.key in [K_UP, K_SPACE]:
                    Globals.key_up = True
                if event.key == K_DOWN:
                    Globals.drop_on = False
                    Globals.drop_counter = 0
        Globals.current_piece.drop()
    except Data.Collision, e:
        if e.error == "Done!":
            GameSounds.TOUCH.play()
            Globals.current_piece.draw(Globals.play_field)
            Globals.next_piece.erase(Globals.next_screen)
            Globals.current_piece = Globals.next_piece
            
            # undo next_piece centering
            Globals.current_piece.move(1, Constants.UP, False)
            Globals.current_piece.move(2, Constants.RIGHT, False)

            # FIXME: check for Game Over
            try: Globals.current_piece.collision_detect()
            except Data.Collision:
                Globals.current_piece.draw(Globals.play_field)
                pygame.display.flip()
                print "Game Over Man!"
                print "Score: %d" % Globals.score
                quit_program()
            
            Globals.next_piece = create_piece()
            # center next piece
            Globals.next_piece.move(1, Constants.RIGHT, False)
            Globals.next_piece.move(1, Constants.DOWN, False)
            Globals.next_piece.draw(Globals.next_screen)
            pygame.display.flip()
            shuffle_play_field()
            delay(time.time(), 300)
            pygame.display.flip()
            Globals.current_piece.reset_hover_time()

def quit_program():
    pygame.mixer.stop()
    GameSounds.YOINK.play()
    while pygame.mixer.get_busy(): time.sleep(.01)
    sys.exit()

def create_piece():
    """Instantiates a random piece and returns it"""
    piece = random.randint(0, 6)
    # FIXME: color range should be in Constants.py
    color = random.randint(0x999999, 0xCCCCCC)
    return Data.Piece(copy.deepcopy(Constants.PIECES[piece]), color)

def drop_blocks(start_row):
    """Drops the play field 1 line from start_row"""
    rows = range(1, start_row + 1)
    rows.reverse()
    for y in rows:
        for x in range(len(Globals.play_field)):
            try:
                block_surf = Globals.play_field[x][y][1]
                above_block = Globals.play_field[x][y - 1]
                # set color and fill to the above block
                Globals.play_field[x][y][0] = above_block[0]
                block_surf.fill(above_block[0])
                # blank the above block
                above_block[0] = 0x000000
                above_block[1].fill(0x000000)
            except IndexError:
                print "index error in drop_blocks!"
                print "The game is probably screwed!"

def shuffle_play_field():
    """Checks for game over and checks if lines were made, if so blank
    them and move everything down, levels up when necessary and adds scores"""
    
    # check for game over by seeing if any of the starting piece
    # blocks are not clear
#     non_free_blocks = 0
#     current_piece = Globals.current_piece
#     for block in ([current_piece.blocks[0]]
#                   + current_piece.blocks[current_piece.state]):
#         if Globals.play_field[block[0]][block[1]][0] != 0x000000:
#             non_free_blocks += 1
#     if non_free_blocks == 4:
#         print "Game Over Man!"
#         print "Score: %d" % Globals.score
#         quit_program()

    # checks if lines were made and if so, clears them
    play_field = Globals.play_field
    row_length = len(play_field)
    col_length = len(play_field[0])
    lines = 0
    for y in range(col_length):
        blocks_in_row = 0
        for x in range(row_length):
            if play_field[x][y][0] != 0x000000:
                blocks_in_row += 1
        if blocks_in_row == row_length:
            lines += 1
            # move everything down
            drop_blocks(y)
    if lines > 0 and lines < 4:
        GameSounds.LINE.play()
    elif lines == 4:
        GameSounds.WHOA.play()
        old_surfs = []
        for surf, coor in Globals.redraw_surfaces:
            old_surfs.append([surf.copy(), coor])

        Globals.scratch_surf = Globals.main_display.copy()
        for x in range(15):
            Globals.main_display.fill(0xFFFFFF)
            for surf, coor in old_surfs:
                Globals.main_display.blit(surf, coor)
            pygame.display.flip()
            Globals.main_display.fill(0x000000)
            for surf, coor in old_surfs:
                Globals.main_display.blit(surf, coor)
            pygame.display.flip()
        # reload background
        Globals.main_display.blit(Globals.scratch_surf, (0,0))
        pygame.display.flip()
#         myimage = pygame.image.load(
#             Globals.background_list[Globals.current_level])
#         myimage = myimage.convert()
#         Globals.main_display.blit(myimage, (0,0))



    # Up score
    Globals.score += Globals.drop_counter
    if lines > 0:
        Globals.score += \
                      Constants.SCORES[lines - 1] * (Globals.current_level + 1)
    touch_score_board(Globals.score_surf, str(Globals.score))

    # Up lines
    Globals.total_lines += lines
    touch_score_board(Globals.lines_surf, str(Globals.total_lines))

    if Globals.total_lines >= ((Globals.current_level + 1)
                               * Globals.level_increment):
        # Level up!
        Globals.current_level += 1
        touch_score_board(Globals.level_surf, str(Globals.current_level))

        # change background
        if Globals.current_level >= 9:
            image2load = -1
        else: image2load = Globals.current_level
        myimage = pygame.image.load(Globals.background_list[image2load])
        myimage = myimage.convert()
        old_surfs = []
        for surf, coor in Globals.redraw_surfaces:
            old_surfs.append([surf.copy(), coor])
        Globals.main_display.blit(myimage, (0,0))
        for surf, coor in old_surfs:
            Globals.main_display.blit(surf, coor)
        # FIXME: should all be in Constants.py
        if Globals.current_speed > 100:
            Globals.current_speed -= Globals.speed_increase
            Globals.next_level += Globals.level_increment
            GameSounds.NEXT.play()

def handle_piece():
    Globals.current_piece.erase(Globals.play_field)
    handle_events()
    Globals.current_piece.draw(Globals.play_field)
    pygame.display.flip()

def delay(start_time, amount):
    """Kill time in milliseconds after a piece drops"""
    # FIXME: I should probably use the clock module for this
    while ((time.time() - start_time)*1000) < amount:
        time.sleep(.01)

def check_pause():
    for event in pygame.event.get():
        if event.type == KEYDOWN:
            if event.key == K_LCTRL:
                # unpause
                Globals.pause = False
                pygame.mixer.unpause()
                Globals.main_display.blit(Globals.scratch_surf, (0,0))

## Initialize the game
initialize_display()
initialize_font()
initialize_event_queue()
GameSounds.BGM.set_volume(.3)
GameSounds.BGM.play(-1)

mymenu = Menu.Menu()
starting_level = mymenu.display()
if starting_level > -1:
    Globals.current_level = starting_level
    Globals.current_speed = 1000 - (Globals.speed_increase
                                    * Globals.current_level)
else:
    quit_program()

initialize_playfield()
initialize_data()
initialize_score_board()

## Main game loop
while 1:

    # sleep each game cycle so we don't take up 100% of the CPU
    time.sleep(.01)

    if not Globals.pause:
        # Watch the maximum framerate    
        Globals.ticks = Globals.clock.tick(42)
        handle_piece()
    else:
        check_pause()
